﻿Public Class Form1
    '/ ＦＴＰクライアントクラス
    Private FtpClient As TKFP.Net.FtpClient
    '/ カレントディレクトリのクラス
    Private CurrentDirectory As TKFP.IO.DirectoryInfo


    '/ 接続開始
    Private Sub button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles button1.Click
        If Not (FtpClient Is Nothing) Then
            Return
        End If
        '接続用の情報作成
        Dim bp As New TKFP.Net.BasicFtpLogon(txtUserID.Text, txtPassword.Text)
        'ＰＯＰクライアントクラスの定義
        FtpClient = New TKFP.Net.FtpClient(bp, txtAddress.Text, 21)
        'パッシブモードに設定
        FtpClient.ConnectionMode = TKFP.Net.ConnectionModes.Passive
        'リストの取得コマンドを設定
        FtpClient.ListType = TKFP.Net.ListType.LIST
        '取得したリスト情報の有効時間を設定
        FtpClient.ListCacheValidityInterval = 60
        FtpClient.FileSystemCacheValidityInterval = 60

        'FTP over SSL/TLSを使用する場合は以下のように設定します
        'FtpClient.AuthenticationProtocol = TKFP.Net.AuthenticationProtocols.Explicit_TLS
        'AddHandler FtpClient.CertificateValidation, AddressOf FtpClient_CertificateValidation

        'LIST情報の解析クラスを指定
        FtpClient.ListDataLoader = New TKFP.IO.UnixListDataLoader        '標準のＦＴＰ（デフォルト）
        'FtpClient.ListDataLoader = New TKFP.IO.MsdosListDataLoader      'IISでディレクトリ表示スタイルをMS-DOSとした場合

        '日本語ファイル名の文字コードを指定
        'FtpClient.FileNameCharset = "sjis" 'シフトJIS（デフォルト）

        'デバッグ用のログ出力ファイルを指定
        'FtpClient.DebugLogFileName = "d:\log.txt"


        'モニタ表示のために送受信イベントを登録
        AddHandler FtpClient.MessageReceive, AddressOf FtpClient_MessageReceive
        AddHandler FtpClient.MessageSend, AddressOf FtpClient_MessageSend
        '接続開始
        If Not FtpClient.Connect() Then
            statusBarPanel1.Text = "接続失敗"
            FtpClient.Close()
            FtpClient = Nothing
            Return
        Else
            statusBarPanel1.Text = "接続成功"
            If FtpClient.IsEncrypted Then
                statusBarPanel1.Text += " (暗号化)"
            End If

            CurrentDirectory = New TKFP.IO.DirectoryInfo(FtpClient, txtDirectory.Text)
            ShowFolder()
        End If
    End Sub 'button1_Click


    '/ サーバーの切断処理
    Private Sub button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles button2.Click
        If FtpClient Is Nothing Then
            Return
        End If
        FtpClient.Close()
        FtpClient = Nothing
        Me.lviFolder.Items.Clear()
        statusBarPanel1.Text = "切断"
    End Sub 'button2_Click


    '/ メッセージの受信イベント
    Private Sub FtpClient_MessageReceive(ByVal sender As Object, ByVal e As TKFP.Net.MessageArgs)
        richTextBox1.SelectionColor = System.Drawing.Color.Blue
        richTextBox1.AppendText(e.Message)
        richTextBox1.Focus()
        richTextBox1.Refresh()
    End Sub 'FtpClient_MessageReceive


    '/ メッセージの送信イベント
    Private Sub FtpClient_MessageSend(ByVal sender As Object, ByVal e As TKFP.Net.MessageArgs)
        richTextBox1.SelectionColor = System.Drawing.Color.Red
        richTextBox1.AppendText(e.Message)
        richTextBox1.Focus()
        richTextBox1.Refresh()
    End Sub 'FtpClient_MessageSend


    '/ フォルダの内容を表示する
    Private Sub ShowFolder()

        FolderName.Text = CurrentDirectory.FullName
        If Not CurrentDirectory.Parent.FullName.StartsWith(txtDirectory.Text) Then
            button3.Enabled = False
        Else
            button3.Enabled = True
        End If
        lviFolder.Items.Clear()
        'サブフォルダの一覧取得
        Dim d As TKFP.IO.DirectoryInfo
        For Each d In CurrentDirectory.GetDirectories()
            lviFolder.Items.Add(New DirectoryItem(d))
        Next d
        'ファイル一覧取得
        Dim f As TKFP.IO.FileInfo
        For Each f In CurrentDirectory.GetFiles()
            lviFolder.Items.Add(New FileItem(f))
        Next f
    End Sub 'ShowFolder


    '/ フォルダの選択処理
    Private Sub lviFolder_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lviFolder.DoubleClick
        If lviFolder.SelectedItems.Count = 0 Then
            Return
        End If
        Dim item As System.Windows.Forms.ListViewItem = lviFolder.SelectedItems(0)

        If TypeOf item Is DirectoryItem Then
            CurrentDirectory = CType(item, DirectoryItem).Directory
            ShowFolder()
        End If
    End Sub 'lviFolder_DoubleClick


    '/ 親ディレクトリへ移動
    Private Sub button3_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles button3.Click
        If FtpClient Is Nothing Then
            Return
        End If
        CurrentDirectory = CurrentDirectory.Parent
        ShowFolder()
    End Sub 'button3_Click


    '/ 選択ファイルのダウンロード
    Private Sub button4_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles button4.Click
        If FtpClient Is Nothing Then
            Return
        End If
        If lviFolder.SelectedItems.Count = 0 Then
            Return
        End If
        Dim item As System.Windows.Forms.ListViewItem = lviFolder.SelectedItems(0)

        If TypeOf item Is FileItem Then
            'サーバーファイル情報
            Dim file As TKFP.IO.FileInfo = CType(item, FileItem).File
            'デフォルトファイル名
            saveFileDialog1.FileName = file.Name
            Select Case saveFileDialog1.ShowDialog()
                Case System.Windows.Forms.DialogResult.OK
                    'ダウンロード
                    file.CopyTo(saveFileDialog1.FileName, True)
            End Select
        End If
    End Sub 'button4_Click


    '/ ファイルのアップロード
    Private Sub button5_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles button5.Click
        If FtpClient Is Nothing Then
            Return
        End If
        Select Case openFileDialog1.ShowDialog()
            Case System.Windows.Forms.DialogResult.OK
                'ローカルのファイル情報
                Dim LocalFile As New System.IO.FileInfo(openFileDialog1.FileName)
                'サーバー用のファイル名作成
                Dim ServerFile As String = CurrentDirectory.FullName + LocalFile.Name
                'サーバー用ファイル情報クラス作成
                Dim file As New TKFP.IO.FileInfo(CurrentDirectory.FtpClient, ServerFile)
                'アップロード
                file.ReadFrom(LocalFile.FullName)
                'カレントフォルダの情報更新
                CurrentDirectory.Refresh()
                '表示情報更新
                ShowFolder()
        End Select
    End Sub 'button5_Click

    'SSLの証明書の確認イベント
    Private Sub FtpClient_CertificateValidation(ByVal sender As Object, ByVal e As TKFP.Net.CertificateValidationArgs)
        '全ての確認要求を許可します
        e.Cancel = False
    End Sub

    '/ ディレクトリ用のListViewItem
    Private Class DirectoryItem
        Inherits System.Windows.Forms.ListViewItem

        Public Directory As TKFP.IO.DirectoryInfo


        Public Sub New(ByVal Directory As TKFP.IO.DirectoryInfo)
            Me.Directory = Directory

            Me.Text = Directory.Name
            Me.SubItems.Add("<dir>")
            Me.SubItems.Add(Directory.Permission.PermissionCode)
            Me.ImageIndex = 0
        End Sub 'New
    End Class 'DirectoryItem
       _

    '/ ファイル用のListViewItem
    Private Class FileItem
        Inherits System.Windows.Forms.ListViewItem
        Public File As TKFP.IO.FileInfo


        Public Sub New(ByVal File As TKFP.IO.FileInfo)
            Me.File = File

            Me.Text = File.Name
            Me.SubItems.Add(File.Length.ToString("#,##0"))
            Me.SubItems.Add(File.Permission.PermissionCode)
            Me.ImageIndex = 1
        End Sub 'New
    End Class 'FileItem 

End Class